#include <iostream>
#include <stdlib.h>
using namespace std;

#include "ReversibleWatermarking.hpp"
#include <vector>

//Pour la fonction de sauvegarde des sites
#include "image.H"
#include "imageio.H"
#include "imagetools.H"

const int ReversibleWatermarking::L = 255; // Les valeurs des pixels appartiennent  l'interval [0 , 255]


bool ReversibleWatermarking::IMPAIR(int x) {
  return (x%2 != 0);
}

bool ReversibleWatermarking::isPresent(int val, const vector<int>& lst) {

  int taille   = lst.size();       //Taille de la liste
  int i        = 0;                //Indice de parcours
  bool present = false;            //Booleen indiquant la prsence
  while ( (i<taille) && (!present) ) {
    present = (val == lst[i]);     //Test de prsence de l'entier val
    i++;
  }
  
  return present;
}    


/*--------------------------------------------------------------------------*
 | embed -- embed a binary message with a reversible watermarking scheme    |
 |                                                                          |
 | Arguments:                                                               |
 |   c -- image to be watermarked                                           |
 |   width -- width of image                                                |
 |   height -- height of image                                              |
 |   m -- message to encoded (expressed as an array of int in [1, n])       |
 |   mLen -- length of message                                              |
 |   cw -- image watermarked                                                | 
 |   n -- constant value upper or equal to 1
 |                                                                          |
 | Return value:                                                            |
 |   none                                                                   |
 *--------------------------------------------------------------------------*/

//void ReversibleWatermarking::embed(const unsigned char *c, // unsigned char *c, //image en entre
//                                   int height,             // nombre de lignes
//                                   int width,              // nombre de colonnes
//                                   int* m,                 // Suite binaire compose de 0 et de 1 ...
//                                   int mLen,                // Longueur du message 
//                                   unsigned char *cw,      // Image marque
//                                   int n) {                // valeur suprieure ou gale  1 : cf. coltuc ICIP 2007
//
//  int imsize = height*width;   // Taille de l'image
//  SITESTATE state;             // Etat d'un site EMBEDDING, NON-EMBEDDING ou ORIGINAL.
//  int i,j,k,s,next;            // Indices de boucle
//  int y;                       // Rsultat de la tranformation T
//  int code;                    // Code correctif
//  vector<int> embedding_sites; // Liste des sites EMBEDDING
//  vector<int> corecting_codes; // Liste des codes de correction
//  
//  for (i=0; i<imsize-1; i++) { // Attention, i<imsize-1
//    
//    y = (n+1)*c[i] - n*c[i+1]; //Transformation T
//    
//    // SI LE SITE i EST UN SITE D'INSERTION   
//    if ( (0 <= y) && (y <= L) && ((y+n) <= L) ) {
//      embedding_sites.push_back(i); // Stockage de i comme site d'insertion
//      cw[i] = y;                   // Aplication de la transformation T au pixel i
//    }
//    
//    // SI LE SITE i N'EST PAS UN SITE D'INSERTION   
//    else {
//
//      next = look_forward_for_next_emmbedding_site(i, c, imsize, n); // next est le prochain site d'insertion
//
//      //PARCOURS DE LA CHAINE DE SITE NON EMBEDDING ET ALTERNANCE DE SITES NON-EMBEDDING et DE SITES NON-MODIFIES
//      if (IMPAIR((next-i))) {
//        //IL FAUT MODIFIER LE SITE i-1 POUR LE FAIRE PASSER EN SITE DE ORIGINAL
//        if (i!=0) {
//          cw[i-1] = c[i-1];           // quivalent  inverser de la transformation T (on remet la valeur originale au pixel i-1)
//#ifndef RELEASE
//          if (embedding_sites[embedding_sites.size()-1] != (i-1)) {
//            cout<<"void ReversibleWatermarking::embed: erreur : le site prcdent n'est pas un embeddingsite ?\n";
//            exit(-1);
//          } 
//#endif //RELEASE
//          embedding_sites.pop_back(); // Suppression du site i-1 comme site d'insertion
//        }
//        state = TO_CORRECT;         // Utilis pour le parcours altern  
//      }
//      else {
//        state = ORIGINAL;           // Utilis pour le parcours altern
//      }
//        
//      //PARCOURS DE LA CHAINE DE SITE NON EMBEDDING ET ALTERNANCE DE SITES NON-EMBEDDING et DE SITES NON-MODIFIES
//      for (j=i; j<next; j++) {
//        if (state == TO_CORRECT) {
//          // LE SITE i N'EST PAS UN SITE D'INSERTION     
//          code  = (c[j] + n*c[j+1]) % (n+1); // Reste de la division par n+1
//          if (c[j] - code < 0) {
//            code  = - ((n+1-code) % (n+1));  // Code ngatif...
//          }
//          cw[j] = c[j] - code;               // Le pixel i est maintenant divible par n+1
//          corecting_codes.push_back(code);   // Liste des code correctif (liste devant tre embarque)
//          state = ORIGINAL;                // Gestion de l'itration suivante
//        }
//        else {//state = ORIGINAL
//          // LE SITE i EST UN SITE NON MODIFIE
//          cw[j] = c[j];                      // rien  faire...
//          state = TO_CORRECT;              // Gestion de l'itration suivante
//        }
//      } //Fin for j
//      
//      i = next-1; // On passe (itration suivante) directement au pixel next...
//    } //Fin du else LE SITE i N'EST PAS UN SITE D'INSERTION
//  } //Fin du for i=0 ...
//
//#ifndef RELEASE
//  saveImageSites( embedding_sites, height, width);
//#endif //RELEASE  
//    
//  // INSERTION A PROPREMENT PARLER
//  cout<<"Il reste  grer la taille des sites d'insertion\n";
//  if (embedding_sites.size() < corecting_codes.size()) {
//    cout<<"Le nombre de site est trop faible...\n";
//    exit(-1);
//  }
//  //INSERTION DES CODES CORRECTIF (PARCOURS DE L'IMAGE DU BAS VERS LE HAUT DE DROITE A GAUCHE)
//  for (k=corecting_codes.size()-1, s=embedding_sites.size()-1; k>=0; k--, s--) {
//    code  = corecting_codes[k]; // Code correctif
//    i     = embedding_sites[s]; // Site d'insertion
//    if ((code == (n-1)) || (code == n)) {
//      cw[i] = cw[i] + n;         // Insertion D'un code spcial pour le dcodeur
//      if (code == (n-1)) {
//        corecting_codes[k] = 1; // n-1 est reprsent par le code 1
//      }
//      else {
//        corecting_codes[k] = 2; // n est reprsent par le code 2
//      }           
//      k--;                      // Astuce un peu lourde et dangereuse (pour mettre le code de n-1 ou n
//    }
//    else {
//      code = code + 1;          // Translation de 1 des codes (gestion du 0)
//      cw[i] = cw[i] + code;     // Insertion
//    }
//  }
//  
//  cout<<"Il reste encore "<<s+1<<" sites d'insertion\n";
//  //INSERTION DU MESSAGE
//  for (; s>=0; s--) {
//    //INSERTION DU MESSAGE
//    i     = embedding_sites[s]; // Site d'insertion
//    cw[i] = cw[i] + 1;           // Insertion d'un 1 pour le moment ...
//  } 
//  
///*  for (i=0; i<imsize; i++) {
//    cout<<(int)cw[i]<<endl;
//  }
//*/
//}


// Le site i est un site de non-insertion; quel est le prochain site d'insertion ?
int ReversibleWatermarking::look_forward_for_next_emmbedding_site(int i, const unsigned char *c, int imsize, int n) {

  int y;                       // Rsultat de la tranformation T
  bool embedding = false;
  int j = i+1;
  
  while ( (!embedding) && (j<imsize-1)) {
    y = (n+1)*c[j] - n*c[j+1]; //Transformation T
    if ( (0 <= y) && (y <= L) && ((y+n) <= L) ) {
      embedding = true;
    }
    else {
      j++;
    }
  }
  
  //Sortie par existance d'un site d'insertion ou par j=imsize-1 (ce qui est correct pour ce que l'on veux faire)
  return j;
}

/*--------------------------------------------------------------------------*
 | extract -- extract a binary message with a reversible watermarking scheme|
 |                                                                          |
 | Arguments:                                                               |
 |   cw -- watermarked image                                                | 
 |   width -- width of image                                                |
 |   height -- height of image                                              |
 |   m -- message to extract (expressed as an array of int in [1, n])       |
 |   mLen -- length of message                                              |
 |   c -- image recovered                                                   |
 |   n -- constant value upper or equal to 1                                |
 |                                                                          |
 | Return value:                                                            |
 |   none                                                                   |
 *--------------------------------------------------------------------------*/
//void ReversibleWatermarking::extract( unsigned char *cw, // image en entre
//                                      int height,        // height of image
//                                      int width,         // width of image
//                                      int* m,            // Suite de coefficient compris dans [1, n]
//                                      int& mLen,         // longueur du message extrait
//                                      unsigned char *c,  // image rebuild
//                                      int n) {           // valeur suprieure ou gale  1 : cf. coltuc ICIP 2007
//                                      
//  int imsize = height*width;   // Taille de l'image
//  int i, w, s;
//  vector<int> site_to_correct; // Liste des sites  corriger
//  vector<int> coefficients;    // Liste des coefficients (= watermark) 
//  bool previousCoeffControlCode = false; 
//   
//  //Recopie de cw dans c (gestion des pixel originaux (ORIGINAL))
//  for (i=0; i<imsize; i++) {
//    c[i] = cw[i];
//  }
//   
//  // ETAPE 1 : RETRAIT DU MESSAGE
//  for (i=imsize-2; i>=0; i--) {
//      
//    w = (cw[i] + n*c[i+1]) % (n+1); // Reste de la division par n+1 
//    
//    //SI LE SITE EST UN SITE NON-EMBEDDING
//    if (w == 0) {
//      site_to_correct.push_back(i);   // Le site i est  corriger (avec les codes correctif)
//      i--;                            // Le site i-1 est un site non modifi (pixel original)
//    }
//    //SI LE SITE EST UN SITE EMBEDDING
//    else {
//         
//      if (previousCoeffControlCode) {
//        if (w == 1) coefficients.push_back(n-1); // Rcupration du coefficient insr sur le site i
//        else        coefficients.push_back(n);   // Rcupration du coefficient insr sur le site i
//        previousCoeffControlCode = false;
//      }
//      else {
//        if (w == n) {
//          //Detection d'un code de controle
//          previousCoeffControlCode = true;
//        }
//        else {
//          coefficients.push_back(w-1);  // Rcupration du coefficient insr sur le site i
//        }
//      }
//             
//      c[i] = cw[i] - w;               // Retrait du coefficient w
//      c[i] = (c[i] + n*c[i+1])/(n+1); // Invertion de la transformation T (on retrouve le pixel original)
//    }       
//  } //Fin for
//
//  // ETAPE 2 : CORRECTION DES SITES NON-EMBEDDING
//  for (s=0; s<site_to_correct.size(); s++) {
//    i    = site_to_correct[s];        // Site  corriger
//    //La ligne ci dessous marche que s'il y a total correspondance entre taille d'un code et taille insertion ...
//    c[i] = cw[i] + coefficients[s];   // Code de correction
//  }
//
//  cout<<"Message insr\n";
//  for (; s<coefficients.size(); s++) {
//    cout<<coefficients[s]<<" ";
//  } 
//}
//
///*-----------------------------------------------------------*/
//void ReversibleWatermarking::embed2(const unsigned char *c, // unsigned char *c, //image en entre
//                                    int height,             // nombre de lignes
//                                    int width,              // nombre de colonnes
//                                    int* m,                 // Suite binaire compose de 0 et de 1 ...
//                                    int mLen,               // Longueur du message 
//                                    unsigned char *cw,      // Image marque
//                                    int n,                  // valeur suprieure ou gale  1 : cf. coltuc ICIP 2007
//                                    vector<int>& corecting_codes) {                
//
//  if (n < 3) {
//    cout<<"ReversibleWatermarking::embed2: Le schma ne peut pas marcher quand n<3  cause de \n";
//    cout<<"                                la contrainte d'insertion (coeff dans [1,n]) et donc du codage \n";
//    cout<<"                                des coefficients de correction qui eux appartiennent  [-n, n]\n";
//    exit(-1);
//  }
//
//  corecting_codes.resize(0);
//  int imsize = height*width;   // Taille de l'image
//  SITESTATE state;             // Etat d'un site EMBEDDING, NON-EMBEDDING ou ORIGINAL.
//  int i,j,k,s,next;            // Indices de boucle
//  int y;                       // Rsultat de la tranformation T
//  int code;                    // Code correctif
//  vector<int> embedding_sites; // Liste des sites EMBEDDING
//  //vector<int> corecting_codes; // Liste des codes de correction
//  
//  for (i=0; i<imsize-1; i++) { // Attention, i<imsize-1
//    
//    y = (n+1)*c[i] - n*c[i+1]; //Transformation T
//    
//    // SI LE SITE i EST UN SITE D'INSERTION   
//    if ( (0 <= y) && (y <= L) && ((y+n) <= L) ) {
//      embedding_sites.push_back(i); // Stockage de i comme site d'insertion
//      cw[i] = y;                    // Aplication de la transformation T au pixel i
//#ifndef RELEASE
//      if ( ((cw[i] + n*c[i+1]) % (n+1)) != 0) {
//        cout<<"ReversibleWatermarking::embed2: La congruence devrait tre nulle (aprs T) pour le pixel "<<i<<endl;
//        exit(-1); 
//      }
//      if ( ((cw[i] + n*c[i+1]) / (n+1)) != c[i]) {
//        cout<<"ReversibleWatermarking::embed2: La reversibilit n'est pas assure pour le pixel "<<i<<endl;
//        exit(-1); 
//      }
//#endif //RELEASE
//    }
//    
//    // SI LE SITE i N'EST PAS UN SITE D'INSERTION   
//    else {
//
//      next = look_forward_for_next_emmbedding_site(i, c, imsize, n); // next est le prochain site d'insertion
//
//      //PARCOURS DE LA CHAINE DE SITE NON EMBEDDING ET ALTERNANCE DE SITES NON-EMBEDDING et DE SITES NON-MODIFIES
//      if (IMPAIR((next-i))) {
//        //IL FAUT MODIFIER LE SITE i-1 POUR LE FAIRE PASSER EN SITE DE ORIGINAL
//        if (i!=0) {
//          cw[i-1] = c[i-1];           // quivalent  inverser de la transformation T (on remet la valeur originale au pixel i-1)
//          embedding_sites.pop_back(); // Suppression du site i-1 comme site d'insertion
//        }
//        state = TO_CORRECT;         // Utilis pour le parcours altern  
//      }
//      else {
//        state = ORIGINAL;           // Utilis pour le parcours altern
//      }
//        
//      //PARCOURS DE LA CHAINE DE SITE NON EMBEDDING ET ALTERNANCE DE SITES NON-EMBEDDING et DE SITES NON-MODIFIES
//      for (j=i; j<next; j++) {
//        if (state == TO_CORRECT) {
//          // LE SITE i N'EST PAS UN SITE D'INSERTION     
//          code  = (c[j] + n*c[j+1]) % (n+1); // Reste de la division par n+1
//          if ((c[j] - code) < 0) {
//            code  = - ((n+1-code) % (n+1));  // Code ngatif...
//          }
//          cw[j] = c[j] - code;               // Le pixel i est maintenant divible par n+1
//#ifndef RELEASE
//          if (((cw[j]+ n*c[j+1]) % (n+1)) != 0) {
//            cout<<"ReversibleWatermarking::embed2: Erreur, valeur de correction ("<<code<<")est fausse\n";
//            exit(-1);
//          }
//#endif //RELEASE
//          corecting_codes.push_back(code);   // Liste des code correctif (liste devant tre embarque)
//          state = ORIGINAL;                  // Gestion de l'itration suivante
//        }
//        else {//state = ORIGINAL
//          // LE SITE i EST UN SITE NON MODIFIE
//          cw[j] = c[j];                     // rien  faire...
//          state = TO_CORRECT;              // Gestion de l'itration suivante
//        }
//      } //Fin for j
//      
//      i = next-1; // On passe (itration suivante) directement au pixel next...
//    } //Fin du else LE SITE i N'EST PAS UN SITE D'INSERTION
//  } //Fin du for i=0 ...
//
//    
//  //INSERTION D'UN 1 POUR LE MOMENT
//  for (s=0; s<embedding_sites.size(); s++) {
//    //INSERTION DU MESSAGE
//    i     = embedding_sites[s]; // Site d'insertion
//    cw[i] = cw[i] + 1;          // Insertion d'un 1 pour le moment ...
//#ifndef RELEASE
//    if( ((cw[i] + n*c[i+1]) % (n+1)) == 0) {
//      cout<<"ReversibleWatermarking::embed2: Erreur le site est une site d'insertion et pourtant la congruence est =  0\n";
//      exit(-1);
//    }
//#endif //RELEASE
//  } 
//#ifndef RELEASE
//  saveImageSites( embedding_sites, height, width);
//#endif //RELEASE  
//
//#ifndef RELEASE
//  checkSchemeReversibility( embedding_sites, c, cw, height, width, n);
//#endif //RELEASE  
//}

void ReversibleWatermarking::embed3( const unsigned char *c,     // unsigned char *c, //image en entre
                                     int height,                 // nombre de lignes
                                     int width,                  // nombre de colonnes
                                     const vector<int>& message, // Suite de coefficients extrait compris dans [0, n-1]
                                     unsigned char *cw,          // Image marque
                                     int n) {                    // valeur suprieure ou gale  1 : cf. coltuc ICIP 2007
  
  vector<int> corecting_codes; // Liste des codes correcteurs
  vector<int> embedding_sites; // Liste des sites EMBEDDING
  
  //STEP1 : - Dtermination des sites d'insertion
  //        - Dtermination des codes correctif
  embed_step1 ( c, height, width, cw, corecting_codes, embedding_sites, n);

  //STEP2 : - Insertion des codes correctif
  //        - Insertion du message
  embed_step2 ( cw, height, width, corecting_codes, embedding_sites, message, n);

#ifndef RELEASE
  checkSchemeReversibility( embedding_sites, c, cw, height, width, n);
#endif //RELEASE  
}

void ReversibleWatermarking::embed_step1 ( const unsigned char *c,       // unsigned char *c, //image en entre
                                           int height,                   // nombre de lignes
                                           int width,                    // nombre de colonnes
                                           unsigned char *cw,            // Image marque
                                           vector<int>& corecting_codes, // Liste des code correcteur               
                                           vector<int>& embedding_sites, // Liste des sites EMBEDDING
                                           int n) {                      // valeur suprieure ou gale  1 : cf. coltuc ICIP 2007

  corecting_codes.resize(0);   // Liste des codes correctif
  embedding_sites.resize(0);   // Liste des sites EMBEDDING
  
  int imsize = height*width;   // Taille de l'image
  SITESTATE state;             // Etat d'un site EMBEDDING, NON-EMBEDDING ou ORIGINAL.
  int i,j,k,s,next;            // Indices de boucle
  int y;                       // Rsultat de la tranformation T
  int code;                    // Code correctif

#ifndef RELEASE
  //PRECONDITIONS                                           
  if (n < 3) {
    cout<<"ReversibleWatermarking::embed2: Le schma ne peut pas marcher quand n<3  cause de \n";
    cout<<"                                la contrainte d'insertion (coeff dans [1,n]) et donc du codage \n";
    cout<<"                                des coefficients de correction qui eux appartiennent  [-n, n]\n";
    exit(-1);
  }
#endif //RELEASE


  
  for (i=0; i<imsize-1; i++) { // Attention, i<imsize-1
    
    y = (n+1)*c[i] - n*c[i+1]; //Transformation T
    
    // SI LE SITE i EST UN SITE D'INSERTION   
    if ( (0 <= y) && (y <= L) && ((y+n) <= L) ) {
      embedding_sites.push_back(i); // Stockage de i comme site d'insertion
      cw[i] = y;                    // Aplication de la transformation T au pixel i
#ifndef RELEASE
      if ( ((cw[i] + n*c[i+1]) % (n+1)) != 0) {
        cout<<"ReversibleWatermarking::embed2: La congruence devrait tre nulle (aprs T) pour le pixel "<<i<<endl;
        exit(-1); 
      }
      if ( ((cw[i] + n*c[i+1]) / (n+1)) != c[i]) {
        cout<<"ReversibleWatermarking::embed2: La reversibilit n'est pas assure pour le pixel "<<i<<endl;
        exit(-1); 
      }
#endif //RELEASE
    }
    
    // SI LE SITE i N'EST PAS UN SITE D'INSERTION   
    else {

      next = look_forward_for_next_emmbedding_site(i, c, imsize, n); // next est le prochain site d'insertion

      //PARCOURS DE LA CHAINE DE SITE NON EMBEDDING ET ALTERNANCE DE SITES NON-EMBEDDING et DE SITES NON-MODIFIES
      if (IMPAIR((next-i))) {
        //IL FAUT MODIFIER LE SITE i-1 POUR LE FAIRE PASSER EN SITE DE ORIGINAL
        if (i!=0) {
          cw[i-1] = c[i-1];           // quivalent  inverser de la transformation T (on remet la valeur originale au pixel i-1)
          embedding_sites.pop_back(); // Suppression du site i-1 comme site d'insertion
        }
        state = TO_CORRECT;         // Utilis pour le parcours altern  
      }
      else {
        state = ORIGINAL;           // Utilis pour le parcours altern
      }
        
      //PARCOURS DE LA CHAINE DE SITE NON EMBEDDING ET ALTERNANCE DE SITES NON-EMBEDDING et DE SITES NON-MODIFIES
      for (j=i; j<next; j++) {
        if (state == TO_CORRECT) {
          // LE SITE i N'EST PAS UN SITE D'INSERTION     
          code  = (c[j] + n*c[j+1]) % (n+1); // Reste de la division par n+1
          if ((c[j] - code) < 0) {
            code  = - ((n+1-code) % (n+1));  // Code ngatif...
          }
          cw[j] = c[j] - code;               // Le pixel i est maintenant divible par n+1
#ifndef RELEASE
          if (((cw[j]+ n*c[j+1]) % (n+1)) != 0) {
            cout<<"ReversibleWatermarking::embed2: Erreur, valeur de correction ("<<code<<")est fausse\n";
            exit(-1);
          }
#endif //RELEASE
          corecting_codes.push_back(code);   // Liste des code correctif (liste devant tre embarque)
          state = ORIGINAL;                  // Gestion de l'itration suivante
        }
        else {//state = ORIGINAL
          // LE SITE i EST UN SITE NON MODIFIE
          cw[j] = c[j];                     // rien  faire...
          state = TO_CORRECT;              // Gestion de l'itration suivante
        }
      } //Fin for j
      
      i = next-1; // On passe (itration suivante) directement au pixel next...
    } //Fin du else LE SITE i N'EST PAS UN SITE D'INSERTION
  } //Fin du for i=0 ...

#ifndef RELEASE
  saveImageSites( embedding_sites, height, width);
#endif //RELEASE  

} 
    
void ReversibleWatermarking::embed_step2 ( unsigned char *cw,                  // Image marque
                                           int height,                         // nombre de lignes
                                           int width,                          // nombre de colonnes
                                           const vector<int>& corecting_codes, // Liste des code correcteur               
                                           const vector<int>& embedding_sites, // Liste des sites EMBEDDING
                                           const vector<int>& message,         // Suite de coefficients extrait compris dans [0, n-1]
                                           int n) {                            // valeur suprieure ou gale  1 : cf. coltuc ICIP 2007

  int imsize = height*width; // Taille de l'image
  int i,k,s;                 // Indices de boucle
  int code;                  // Code correctif

#ifndef RELEASE
  for(i=0; i<message.size(); i++) {
    if ( (message[i] <0) || (message[i]>(n-1)) ) {
      cout<<"ReversibleWatermarking::embed2: Le message contient des coefficients en dehors de l'intervalle [0,"<<n-1<<"]\n";
      exit(-1);
    }
  }
#endif //RELEASE

  cout<<"Nombre de code correctif    = "<<corecting_codes.size()<<endl;
  cout<<"Nombre de sites d'insertion = "<<embedding_sites.size()<<endl;
  cout<<"  (n = "<<n<<", Nombre de sites d'insertion * log2(n) = "<<embedding_sites.size()*log2(n)<<"bits)\n";
  cout<<"  (n = "<<n<<",                                       = "<<embedding_sites.size()*log2(n)/(double)(width*height)<<"bpp)\n";

  //INSERTION DES CODES CORRECTIF (PARCOURS DE L'IMAGE DE HAUT EN BAS ET DE GAUCHE A DROITE)
  for (k=0, s=0; k<corecting_codes.size(); k++, s++) {
      
    code  = corecting_codes[k];         // Code correctif
    if (s >= embedding_sites.size()) {
      cout<<"ReversibleWatermarking::embed_step2: Erreur, pas assez de capacit d'insertion\n";
      exit(-1);
    }
    i     = embedding_sites[s];         // Site d'insertion

    // SI L'ON EST DANS UN CAS NORMAL
    if ( (code >= 0) && (code < n-2) ) {
      cw[i] = cw[i] + code+1;           // Insertion avec translation de 1 des codes (gestion du 0)
    }
    else {
      // SI L'ON EST DANS LE CAS THREELASTVALUECODE
      if ( code >= n-2 ) {              // Code est n-2 ou n-1 ou n
        cw[i] = cw[i] + n-1;            // Insertion D'un code spcial n-1 pour le dcodeur
        s = s+1;                        // Passage au site suivant d'insertion
        if (s<embedding_sites.size()) {
          i     = embedding_sites[s];   // Site d'insertion
#ifndef RELEASE          
          if ( ((code-n+3) <= 0) || ((code-n+3) > n) ) {
            cout<<"ReversibleWatermarking::embed_step2: Erreur, cas THREELASTVALUECODE, le code insr est hors bornes [1, "<<n<<"]\n";
            cout<<"ReversibleWatermarking::embed_step2: Le code insr est"<<(code-n+3)<<endl;
            exit(-1);
          }
#endif //RELEASE
          cw[i] = cw[i] + code-n+3;     // Insertion d'un code spcial pour le dcodeur (n-2) -> 1; (n-1) -> 2; (n) -> 3
//          switch (code) {
//            
//            case (n-2):                   //Insertion de la valeur 1
//              cw[i] = cw[i] + 1;        // Insertion D'un code spcial pour le dcodeur
//            break;
//            case (n-1):                   //Insertion de la valeur 2
//              cw[i] = cw[i] + 2;        // Insertion D'un code spcial pour le dcodeur
//            break;
//            case n:                     //Insertion de la valeur 3
//              cw[i] = cw[i] + 3;        // Insertion D'un code spcial pour le dcodeur
//            break;
//          } //Fin switch
        }
        else {
          cout<<"ReversibleWatermarking::embed_step2: Erreur, pas assez de capacit d'insertion\n";
          exit(-1);
        }
      } 
      // SI L'ON EST DANS LE CAS NEGATIVECODE
      else {
        cout<<"Cas exceptionel d'insertion d'un code correctif ngatif\n";
        cw[i] = cw[i] + n;              // Insertion D'un code spcial n pour le dcodeur
        s = s+1;                        // Passage au site suivant d'insertion
        if (s<embedding_sites.size()) {
          i = embedding_sites[s];       // Site d'insertion
          cw[i] = cw[i] - code;         // Insertion de la valeur positive du code
        }
        else {
          cout<<"ReversibleWatermarking::embed_step2: Erreur, pas assez de capacit d'insertion\n";
          exit(-1);
        }
      }        
    }
  } //For (parcours des codes correctif)
  
  cout<<"Il reste (aprs insertion des codes correctif) "<<embedding_sites.size()-s<<" sites d'insertion pour insrer le message\n";
  cout<<" c'est  dire "<<log2(n)*(embedding_sites.size()-s)<<" bits\n"; //n symboles possible sur le range [0, n-1]
  cout<<" on a donc une capacit rel de "<<log2(n)*(embedding_sites.size()-s)/(double)(height*width)<<" bits par pixels\n";

  //INSERTION DU MESSAGE
  for (k=0; (s<embedding_sites.size()) && (k<message.size()); s++, k++) {
    //INSERTION DU MESSAGE
    i     = embedding_sites[s];     // Site d'insertion
    cw[i] = cw[i] + message[k] + 1; // translation des valeurs pour qu'elle soient dans [1, n]
  } 
  if (s<embedding_sites.size()) {
    for (; s<embedding_sites.size(); s++) {
      //PADDING A 1
      i     = embedding_sites[s];     // Site d'insertion
      cw[i] = cw[i] + 1;              // Insertion de 1
    }
  }
  else {
    cout<<"ReversibleWatermarking::embed_step2: pas assez de capacit pour insrer tout le message\n";
  }
  //cout<<"Sortie force\n";
  //exit(1);
}

void ReversibleWatermarking::get_message_and_correctingcode( const vector<int>& coefficients, // liste des coefficients extrait
                                                             int nbSitesToCorrect,            // Nombre de sites  corriger        
                                                             vector<int>& corecting_codes,    // liste des sites  corriger en step 2
                                                             vector<int>& message,            // Suite de coefficients extrait compris dans [0, n-1]
                                                             int n) {                         // valeur suprieure ou gale  1 : cf. coltuc ICIP 2007

  int c,w;
  enum TYPECODE {NORMALCODE, THREELASTVALUECODE, NEGATIFCODE};
  bool stillCorrectingCode = true; // Correcting codes
  TYPECODE previous = NORMALCODE;  // Etat courant des codes
  
  corecting_codes.resize(0);
  message.resize(0);
                             
  //PARCOURS DU PREMIER COEFFICIENT INSR (= dernier extrait) JUSQU'AU DERNIER INSR (= premier extrait)                                   
  for (c=coefficients.size()-1; c>=0; c--) {
    w = coefficients[c]; //Extraction du coefficient
    //cout<<w<<" , ";  
    
    if (stillCorrectingCode) {
      
      switch (previous) {

        case THREELASTVALUECODE:
          switch (w) {
            case 1 : //Insertion de n-2
              corecting_codes.push_back(n-2);   
            break;
            case 2 : //Insertion de n-1
              corecting_codes.push_back(n-1);
            break;
            case 3 : //Insertion de n
              corecting_codes.push_back(n);
            break;
            default:
              cout<<"ReversibleWatermarking::get_message_and_correctingcode: Erreur, THREELASTVALUECODE, code incorrect="<<w<<endl;
              exit(-1);
            break;
          }
          previous = NORMALCODE; //Gestion du type de code suivant
        break;
      
        case NEGATIFCODE:
          corecting_codes.push_back(-w);           
          previous = NORMALCODE; //Gestion du type de code suivant
        break;

        case NORMALCODE:          
          if (w == n-1) {
            previous = THREELASTVALUECODE;  // Gestion du type de code suivant   
          }
          else {
          if (w == n) {
              previous = NEGATIFCODE;       // Gestion du type de code suivant   
          }
          else {
            corecting_codes.push_back(w-1); // Rcupration du code (translation de la valeur de 1)
          }}
        break;
      } //Fin switch previous

      //TEST DE FIN DE COLLECTE ...
      if (corecting_codes.size() == nbSitesToCorrect) {
        stillCorrectingCode = false; //On a fini de collecter tous les codes...
      }

    } //Fin du if stillCorrectingCode
             
    else {
      message.push_back(w-1);
    }
  } // fin du for
}

//void ReversibleWatermarking::extract2( unsigned char *cw, // image en entre
//                                       int height,        // height of image
//                                       int width,         // width of image
//                                       int* m,            // Suite de coefficient compris dans [1, n]
//                                       int& mLen,         // longueur du message extrait
//                                       unsigned char *c,  // image rebuild
//                                       int n,             // valeur suprieure ou gale  1 : cf. coltuc ICIP 2007
//                                       const vector<int>& corecting_codes) {                
//                                                                            
//  int imsize = height*width;   // Taille de l'image
//  int i, w, s, k;
//  int code;
//  vector<int> site_to_correct; // Liste des sites  corriger
//  vector<int> coefficients;    // Liste des coefficients (= watermark) 
//      
//  //Recopie de cw dans c (gestion des pixel originaux (ORIGINAL))
//  for (i=0; i<imsize; i++) {
//    c[i] = cw[i];
//  }
//   
//  // ETAPE 1 : RETRAIT DU MESSAGE
//  for (i=imsize-2; i>=0; i--) {
//      
//    w = (cw[i] + n*c[i+1]) % (n+1);  // Reste de la division par n+1 
//    
//    //SI LE SITE EST UN SITE NON-EMBEDDING
//    if (w == 0) {
//      site_to_correct.push_back(i);   // Le site i est  corriger (avec les codes correctif)
//      i--;                            // Le site i-1 est un site non modifi (pixel original)
//    }
//    //SI LE SITE EST UN SITE EMBEDDING
//    else {
//      //cout<<w<<" ";                     
//#ifndef RELEASE
//      if (w != 1) {
//        cout<<"w!=1; position : (li,co) = ("<<i/width<<" , "<<i%width<<")\n";
//        cout<<"n = "<<n<<", cw[i] = "<<(int)cw[i]<<", c[i+1] = "<<(int)c[i+1]<<endl;
//        exit(1);
//      }
//#endif //RELEASE
//      c[i] = cw[i] - w;               // Retrait du coefficient w
//      c[i] = (c[i] + n*c[i+1])/(n+1); // Invertion de la transformation T (on retrouve le pixel original)
//      coefficients.push_back(w);
//    }       
//  } //Fin for
//
//  saveImageSites_Decodeur(site_to_correct, height, width);
//
//  if (site_to_correct.size() != corecting_codes.size()) {
//    cout<<"extract2: Erreur le nombre de site  corriger n'est pas le mme qu' l'insertion\n";
//    cout<<"  site_to_correct.size() = "<<site_to_correct.size()<<endl;
//    cout<<"  corecting_codes.size() = "<<corecting_codes.size()<<endl;
//    exit(-1);
//  }  
//
//  // ETAPE 2 : CORRECTION DES SITES NON-EMBEDDING
//  for (s=site_to_correct.size()-1, k=0; s>=0; s--, k++) {
//    code = corecting_codes[k]; // code correctif
//    //cout<<code<<" , ";
//    i    = site_to_correct[s]; // Site  corriger
//    c[i] = cw[i] + code;       // Code de correction
//  }
//}

void ReversibleWatermarking::extract3( unsigned char *cw, // image en entre
                                       int height,        // height of image
                                       int width,         // width of image
                                       vector<int>& message, // Suite de coefficients extrait compris dans [0, n-1]
                                       unsigned char *c,  // image rebuild
                                       int n) {           // valeur suprieure ou gale  1 : cf. coltuc ICIP 2007

  vector<int> coefficients;    // liste des coefficients extrait en step 1
  vector<int> site_to_correct; // liste des sites  corriger en step 2
  
  // STEP 1 : - Corrige les sites EMBEDDING, 
  //          - extrait les coefficients embarqus 
  //          - et extrait les sites  corriger
  extract_step1 ( cw, height, width, c, coefficients, site_to_correct, n);
  
  // STEP 2 : - Extrait le message
  //          - et corrige les sites  corriger
  extract_step2 ( cw, height, width, coefficients, site_to_correct, message, c, n);
}  

void ReversibleWatermarking::extract_step1 ( const unsigned char *cw,      // image en entre
                                             int height,                   // height of image
                                             int width,                    // width of image
                                             unsigned char *c,             // image rebuild
                                             vector<int>& coefficients,    // liste des coefficients extrait
                                             vector<int>& site_to_correct, // liste des sites  corriger en step 2
                                             int n) {                      // valeur suprieure ou gale  1 : cf. coltuc ICIP 2007

  int imsize = height*width; // Taille de l'image
  int i;                     // indice de boucle
  int w;                     // Reste de la division par n+1

  site_to_correct.resize(0); // Liste des sites  corriger
  coefficients.resize(0);    // Liste des coefficients embarqus
      
  //Recopie de cw dans c (gestion des pixel originaux (ORIGINAL))
  for (i=0; i<imsize; i++) {
    c[i] = cw[i];
  }
   
  // ETAPE 1 : RETRAIT DU MESSAGE
  for (i=imsize-2; i>=0; i--) {
      
    w = (cw[i] + n*c[i+1]) % (n+1);   // Reste de la division par n+1 
    
    //SI LE SITE EST UN SITE TO-CORRECT
    if (w == 0) {
      site_to_correct.push_back(i);   // Le site i est  corriger (avec les codes correctif)
      i--;                            // Le site i-1 est un site non modifi (pixel original)
    }
    //SI LE SITE EST UN SITE EMBEDDING
    else {
      coefficients.push_back(w);      // Stockage du coefficient
      c[i] = cw[i] - w;               // Retrait du coefficient w
      c[i] = (c[i] + n*c[i+1])/(n+1); // Invertion de la transformation T (on retrouve le pixel original)
    }       
  } //Fin for

#ifndef RELEASE  
  saveImageSites_Decodeur(site_to_correct, height, width);
#endif RELEASE
}

void ReversibleWatermarking::extract_step2 ( const unsigned char *cw,            // image en entre
                                             int height,                         // height of image
                                             int width,                          // width of image
                                             const vector<int>& coefficients,    // liste des coefficients extrait
                                             const vector<int>& site_to_correct, // liste des sites  corriger en step 2
                                             vector<int>& message,               // Suite de coefficients extrait compris dans [0, n-1]
                                             unsigned char *c,                   // image rebuild
                                             int n) {                            // valeur suprieure ou gale  1 : cf. coltuc ICIP 2007
                                             
  int imsize = height*width;   // Taille de l'image
  int s,k,i;                   // indice de boucle
  int code;                    // Code correctif
  vector<int> corecting_codes; // Codes de correction des sites TO-CORRECT
  int nbSitesToCorrect = site_to_correct.size(); //Nombre de site  corriger

  //DETERMINATION DES LISTES - CORRECTING CODES et - MESSAGE
  get_message_and_correctingcode(coefficients, nbSitesToCorrect, corecting_codes, message, n); 

  // ETAPE 2 : CORRECTION DES SITES NON-EMBEDDING
  for (s=0; s<nbSitesToCorrect; s++) {
    code = corecting_codes[s];                    // code correctif
    i    = site_to_correct[nbSitesToCorrect-1-s]; // Site  corriger (les sites sont stock dans le sens inverse de parcours classique (fin vers dbut))
    c[i] = cw[i] + code;                          // Code de correction
  }
}

/*--------------------------------------------------------------------------*
 | checkSchemeReversibility -- mthode de debugage                          |
 | vrifie que le schma est bien rversible...                             |                                             | 
 |                                                                          |
 | Arguments:                                                               |
 |   embedding_sites -- site d'insertion                                    |
 |   c -- image originale                                                   |
 |   cw -- image tatoue                                                    |
 |   height -- height of image                                              |
 |   width -- width of image                                                |
 |   n -- valeur ncessaire aux calcul de reste                             |
 |                                                                          |
 | Return value:                                                            |
 |   none                                                                   |
 *--------------------------------------------------------------------------*/
void ReversibleWatermarking::checkSchemeReversibility ( const vector<int>& embedding_sites, 
                                                        const unsigned char *c,  //image en entre
                                                        const unsigned char *cw, //image en entre
                                                        int height,              // nombre de lignes
                                                        int width,               // nombre de colonnes 
                                                        int n) {                 

  int w, i, s, imsize = height*width;         // Taille de l'image  
  Image<SITESTATE> imageSites(height, width); // Image de l'tat de chaque site
  int first_embedding_site;                   //Premier site d'insertion

  // Init  ORIGINAL de tout les pixels
  for (i=0; i<imsize; i++) {
    imageSites[i] = UNDEFINE;
  }
    
  // Remplissage des sites EMBEDDING
  for (s=0; s<embedding_sites.size(); s++) {
    i             = embedding_sites[s];  
    imageSites[i] = EMBEDDING;
  }

  // Traitement du cas du premier pixel N'ETANT PAS EMBEDDING
  i = 0;
  first_embedding_site = embedding_sites[0]; //Premier site d'insertion
  //cout<<"ReversibleWatermarking::checkSchemeReversibility: first_embedding_site = "<<first_embedding_site<<endl;
  if ( first_embedding_site > 0) {
    if (IMPAIR(first_embedding_site)) {
      for (; i<first_embedding_site; i++) {
        if ( imageSites[i] == UNDEFINE ) {
          //cout<<"ReversibleWatermarking::checkSchemeReversibility: pixel ("<<i/width<<","<<i%width<<") est TO_CORRECT\n";
          imageSites[i] = TO_CORRECT;
        }
        else {
          cout<<"ReversibleWatermarking::checkSchemeReversibility: Erreur, site "<<i<<" est dj attribu...\n";
          exit(-1);
        }
        i = i+1; // On passe au pixel suivant
        if (i < imsize) {
          if (i < first_embedding_site) { 
            if ( imageSites[i] == UNDEFINE ) {
              //cout<<"ReversibleWatermarking::checkSchemeReversibility: pixel ("<<i/width<<","<<i%width<<") est ORIGINAL\n";
              imageSites[i] = ORIGINAL;
            }
            else {
              cout<<"ReversibleWatermarking::checkSchemeReversibility: Erreur, site "<<i<<" est dj attribu...\n";
              exit(-1);
            }
          }
          else {
            i--; //Pour grer de manire propre les incrments de i (en sortie de boucle)
          }
        }          
        else {
          cout<<"ReversibleWatermarking::checkSchemeReversibility: Erreur\n";
          exit(-1);
        }
      } //Fin du for
    } 
  }

  
  // Remplissage des sites TO_CORRECT + ORIGINAL
  for (; i<imsize; i++) {
    if ( imageSites[i] == UNDEFINE ) {
      imageSites[i] = ORIGINAL;
      i = i+1; // On passe au pixel suivant
      if (i < imsize) {
        if ( imageSites[i] == UNDEFINE ) {
          imageSites[i] = TO_CORRECT;
        }
        else {
          cout<<"ReversibleWatermarking::checkSchemeReversibility: Erreur, site "<<i<<" est dj attribu...\n";
          cout<<"ReversibleWatermarking::checkSchemeReversibility: etat (EMBEDDING="<<EMBEDDING<<", TO_CORRECT="<<TO_CORRECT<<", ORIGINAL="<<ORIGINAL<<", UNDEFINE="<<UNDEFINE<<") = "<<imageSites[i]<<endl;
          exit(-1);
        }
      }          
    }
  } //Fin du for  
  
  // Check sites
  for (i=0; i<imsize; i++) {
    //cout<<"ReversibleWatermarking::checkSchemeReversibility: pixel ("<<i/width<<","<<i%width<<") : cw[i] = "<<(int)cw[i]<<", c[i] = "<<(int)c[i]<<", c[i+1] = "<<(int)c[i+1]<<", (cw[i] + n*c[i+1]) % (n+1) = "<<(cw[i] + n*c[i+1]) % (n+1)<<endl;
    switch (imageSites[i]) {
      case ORIGINAL:
        //cout<<"ReversibleWatermarking::checkSchemeReversibility: +-> ORIGINAL\n";
        if (cw[i] != c[i]) {
          cout<<"ReversibleWatermarking::checkSchemeReversibility: Erreur, le pixel ("<<i/width<<","<<i%width<<") est cens tre un pixel ORIGINAL\n";
          cout<<"ReversibleWatermarking::checkSchemeReversibility: +-> cw[i] = "<<(int)cw[i]<<", c[i+1] = "<<(int)c[i+1]<<", (cw[i] + n*c[i+1]) % (n+1) = "<<(cw[i] + n*c[i+1]) % (n+1)<<endl;
          if (i<imsize-1) {
            switch (imageSites[i+1]) {
              case ORIGINAL:
                cout<<"ReversibleWatermarking::checkSchemeReversibility: +--> tat du pixel suivant = ORIGINAL\n";
                break;
              case TO_CORRECT:
                cout<<"ReversibleWatermarking::checkSchemeReversibility: +--> tat du pixel suivant = TO_CORRECT\n";
                break;
              case EMBEDDING:
                cout<<"ReversibleWatermarking::checkSchemeReversibility: +--> tat du pixel suivant = EMBEDDING\n";
                break;
            }
          }                 
          cout<<"ReversibleWatermarking::checkSchemeReversibility: +--> cw[i] = "<<(int)cw[i]<<", c[i] = "<<(int)c[i]<<endl;
        }
      break;
      case TO_CORRECT:
        //cout<<"ReversibleWatermarking::checkSchemeReversibility: +-> TO_CORRECT\n";
        w = (cw[i] + n*c[i+1]) % (n+1);  // Reste de la division par n+1 
        if ( w != 0) {
          cout<<"ReversibleWatermarking::checkSchemeReversibility: Erreur, le pixel ("<<i/width<<","<<i%width<<") est cens tre un pixel TO_CORRECT et dtect EMBEDDING...ou ORIGINAL ...\n";
          cout<<"ReversibleWatermarking::checkSchemeReversibility: +-> cw[i] = "<<(int)cw[i]<<", c[i+1] = "<<(int)c[i+1]<<", (cw[i] + n*c[i+1]) % (n+1) = "<<w<<endl;
          cout<<"ReversibleWatermarking::checkSchemeReversibility: +-> c[i]  = "<<(int)c[i]<<endl;
        }                                
      break;
      case EMBEDDING:
        //cout<<"ReversibleWatermarking::checkSchemeReversibility: +-> EMBEDDING\n";
        w = (cw[i] + n*c[i+1]) % (n+1);  // Reste de la division par n+1 
        if ( w == 0) {
          cout<<"ReversibleWatermarking::checkSchemeReversibility: Erreur, le pixel ("<<i/width<<","<<i%width<<") est cens tre un pixel EMBEDDING et dtect TO_CORRECT\n";
          cout<<"ReversibleWatermarking::checkSchemeReversibility: +--> cw[i] = "<<(int)cw[i]<<", c[i+1] = "<<(int)c[i+1]<<", (cw[i] + n*c[i+1]) % (n+1) = "<<w<<endl;
        }                                          
      break;
      case UNDEFINE:
          cout<<"ReversibleWatermarking::checkSchemeReversibility: Erreur, le pixel ("<<i/width<<","<<i%width<<") est UNDEFINE\n";
      break;
    }
  }
}

/*--------------------------------------------------------------------------*
 | saveImageSites -- crit sur disque l'image des sites                     |
 |                                                                          | 
 | SAUVEGARDE DE L'IMAGE DES DIFFERENTS SITES                               |
 |   NOIR  -> ORIGINAL                                                      |
 |   ROUGE -> TO_CORRECT                                                    |
 |   BLANC -> EMBEDDING                                                     |
 |                                                                          |
 | Arguments:                                                               |
 |   embedding_sites -- site d'insertion                                    |
 |   width -- width of image                                                |
 |   height -- height of image                                              |
 |                                                                          |
 | Return value:                                                            |
 |   none                                                                   |
 *--------------------------------------------------------------------------*/
void ReversibleWatermarking::saveImageSites( const vector<int>& embedding_sites, // Liste des sites EMBEDDING
                                             int height,
                                             int width) {

  int i, s, imsize = height*width;   // Taille de l'image  
  int first_embedding_site;          //Premier site d'insertion
  Image<RGB> imageSites(height, width);

  if (embedding_sites.size() == 0) {
    cout<<"ReversibleWatermarking::saveImageSites: Pas de sites d'insertion ! \n";
    exit(-1);
  }

  //Init 
  for (i=0; i<imsize; i++) {
    imageSites[i].R = 0;
    imageSites[i].G = 255;
    imageSites[i].B = 0;
  }
  
  //Remplissage des sites EMBEDDING (BLANC)
  for (s=0; s<embedding_sites.size(); s++) {
    i = embedding_sites[s];  
    imageSites[i].R = 255;
    imageSites[i].G = 255;
    imageSites[i].B = 255;
  }

  i = 0;
  first_embedding_site = embedding_sites[0]; //Premier site d'insertion
  //Traitement du CAS PAS D'INSERTION EN 0
  //Remplissage des sites TO_CORRECT (ROUGE) + ORIGINAL (NOIR)
  if ( first_embedding_site > 0) {
    cout<<"ReversibleWatermarking::saveImageSites: embedding_sites[0] = "<<first_embedding_site<<endl;
    if (IMPAIR(first_embedding_site)) {
      cout<<"ReversibleWatermarking::saveImageSites: IMPAIR(embedding_sites[0]) ; cas spcial\n";
      for (; i<first_embedding_site; i++) {
        if ( (imageSites[i].R == 0) && (imageSites[i].G == 255) && (imageSites[i].B == 0)) {
          imageSites[i].R = 255;
          imageSites[i].G = 0;
          imageSites[i].B = 0;
        }
        else {
          cout<<"ReversibleWatermarking::saveImageSites: Erreur, site "<<i<<" est dj attribu...\n";
          exit(-1);
        }
        i = i+1; // On passe au pixel suivant
        if (i < imsize) {
          if (i < first_embedding_site) { 
            if ( (imageSites[i].R == 0) && (imageSites[i].G == 255) && (imageSites[i].B == 0)) {
              imageSites[i].R = 0;
              imageSites[i].G = 0;
              imageSites[i].B = 0;
            }
            else {
              cout<<"ReversibleWatermarking::saveImageSites: Erreur, site "<<i<<" est dj attribu...\n";
              exit(-1);
            }
          }
          else {
            i--; //Pour grer de manire propre les incrments de i (en sortie de boucle)
          }
        }          
        else {
          cout<<"ReversibleWatermarking::saveImageSites: Erreur\n";
          exit(-1);
        }
      } //Fin du for
    } 
  }

  //Remplissage des sites TO_CORRECT (ROUGE) + ORIGINAL (NOIR)
  for (; i<imsize; i++) {
    if ( (imageSites[i].R == 0) && (imageSites[i].G == 255) && (imageSites[i].B == 0)) {
      imageSites[i].R = 0;
      imageSites[i].G = 0;
      imageSites[i].B = 0;
      i = i+1; // On passe au pixel suivant
      if (i < imsize) {
        if ( (imageSites[i].R == 0) && (imageSites[i].G == 255) && (imageSites[i].B == 0)) {
          imageSites[i].R = 255;
          imageSites[i].G = 0;
          imageSites[i].B = 0;
        }
        else {
          cout<<"ReversibleWatermarking::saveImageSites: Erreur, site "<<i<<" est dj attribu...\n";
          exit(-1);
        }
      }          
    }
  } //Fin du for

  ImageIO<RGB>::WritePPM("sites.ppm", imageSites);
}

/*--------------------------------------------------------------------------*
 | saveImageSites2 -- crit sur disque l'image des sites                     |
 |                                                                          | 
 | SAUVEGARDE DE L'IMAGE DES DIFFERENTS SITES                               |
 |   NOIR  -> ORIGINAL                                                      |
 |   ROUGE -> TO_CORRECT                                                    |
 |   BLANC -> EMBEDDING                                                     |
 |                                                                          |
 | Arguments:                                                               |
 |   sites -- chaque site est dans un des 3 tats possibles                 |
 |                                                                          |
 | Return value:                                                            |
 |   none                                                                   |
 *--------------------------------------------------------------------------*/

void ReversibleWatermarking::saveImageSites2( const Image<ReversibleWatermarking::SITESTATE>& sites) {
     
  int i, imsize = sites.NbRow()*sites.NbCol();      // Taille de l'image  
  Image<RGB> imageSites(imageSites.NbRow(), imageSites.NbCol());
  RGB noir (0  ,0,0);
  RGB rouge(255,0,0);
  RGB blanc(0  ,0,0);

  for (i=0; i<imsize; i++) {
    switch (sites[i]) {
      case ORIGINAL:
        imageSites[i] = noir;
      break;
      case TO_CORRECT:
        imageSites[i] = rouge;
      break;
      case EMBEDDING:
        imageSites[i] = rouge;
      break;
    }
  }               

  ImageIO<RGB>::WritePPM("sites.ppm", imageSites);
}

/*--------------------------------------------------------------------------*
 | saveImageSites2 -- crit sur disque l'image des sites dtermins         |
 |                    au dcodeur                                           |
 |                                                                          | 
 | SAUVEGARDE DE L'IMAGE DES DIFFERENTS SITES                               |
 |   NOIR  -> ORIGINAL                                                      |
 |   ROUGE -> TO_CORRECT                                                    |
 |   BLANC -> EMBEDDING                                                     |
 |                                                                          |
 | Arguments:                                                               |
 |   sites_to_correct -- site  corriger                                    |
 |   width -- width of image                                                |
 |   height -- height of image                                              |
 |                                                                          |
 | Return value:                                                            |
 |   none                                                                   |
 *--------------------------------------------------------------------------*/

void ReversibleWatermarking::saveImageSites_Decodeur( const vector<int>& site_to_correct, // Liste des sites TO_CORRECT
                                                      int height,
                                                      int width) {

  int i, s, imsize = height*width;   // Taille de l'image  
  Image<RGB> imageSites(height, width);

  //Init 
  for (i=0; i<imsize; i++) {
    imageSites[i].R = 0;
    imageSites[i].G = 255;
    imageSites[i].B = 0;
  }
  
  //Remplissage des sites TO_CORRECT (ROUGE) + ORIGINAL (NOIR)
  for (s=0; s<site_to_correct.size(); s++) {
    i = site_to_correct[s];  
    imageSites[i].R = 255;
    imageSites[i].G = 0;
    imageSites[i].B = 0;
    i=i-1;
    if (i >=0) {
      if ( (imageSites[i].R == 0) && (imageSites[i].G == 255) && (imageSites[i].B == 0)) {
        imageSites[i].R = 0;
        imageSites[i].G = 0;
        imageSites[i].B = 0;
      }
      else {
        cout<<"ReversibleWatermarking::embed: Erreur, site "<<i<<" est dj attribu...\n";
        exit(-1);
      }
    }
  }

  //Remplissage des sites EMBEDDING (BLANC)
  for (i=0; i<imsize; i++) {
    if ( (imageSites[i].R == 0) && (imageSites[i].G == 255) && (imageSites[i].B == 0)) {
      imageSites[i].R = 255;
      imageSites[i].G = 255;
      imageSites[i].B = 255;
    }
  } //Fin du for
  
  ImageIO<RGB>::WritePPM("sites_decodeur.ppm", imageSites);
}
